import os
os.environ['SDL_VIDEO_CENTERED'] = '1'

import pygame
from pygame.locals import *

class Controller:
    def __init__(self,caption,resolution):
        pygame.mixer.pre_init(44100,-16,2,1024)
        pygame.mixer.init()
        pygame.display.init()
        pygame.display.set_caption(caption)
        self.screen = pygame.display.set_mode(resolution)
        self.running = True
        self.views = []
    def run(self):
        clock = pygame.time.Clock()
        while self.running:
            clock.tick()
            if not len(self.views): break
            for event in pygame.event.get():
                if event.type==QUIT: self.quit()
                self.top().handle(event)
            for view in self.views: view.update(clock.get_time())
            for view in self.views: view.render(self.screen)
            pygame.display.flip()
            #print clock.get_fps()
    def top(self):
        return self.views[len(self.views)-1]
    def push(self,view):
        if len(self.views): self.top().disappear()
        view.controller = self
        self.views.append(view)
        if len(self.views): self.top().appear()
    def pop(self):
        if len(self.views): self.top().disappear()
        view = self.views.pop()
        view.controller = None
        if len(self.views): self.top().appear()
    def quit(self):
        self.running = False