from __future__ import division

import math

LOOP = lambda t: math.modf(t)[0]
STOP = lambda t: max(0,min(1,t))
EASE = lambda t: ((-math.cos(max(0,min(1,t))*math.pi))+1)/2

class Interpolator:
    def __init__(self,duration,behavior=STOP):
        self.duration = duration
        self.action = lambda t:None
        self.behavior = behavior
        self.started = lambda:None
        self.stopped = lambda:None
        self.stop()
    def start(self):
        self.running = True
    def stop(self):
        self.current = 0
        self.running = False
    def pause(self):
        self.running = False
    def update(self,delta):
        if self.running:
            last = (self.behavior)(self.current/self.duration)
            next = (self.behavior)((self.current+delta)/self.duration)
            if last <= 0 < next: (self.started)()
            self.action(next)
            if last < 1 <= next: (self.stopped)()
            self.current += delta