import copy

"""
Utilities for working with grammars
"""

def assign(x,y):
    def assigner(x,y,z):x[y]=z
    return lambda z:assigner(x,y,z)

def identity():
    return lambda x:x

def value(x):
    return lambda y:x

def translate(x):
    return lambda y:x[y]

def output(x):
    def printer(x):print x
    return lambda y:printer(x)

class Sequence:
    def __init__(self,dictionary,head,tail):
        self.head = head
        self.tail = tail
        self.dictionary = dictionary
        self.current = None
    def __len__(self):
        def len(dictionary):
            if dictionary is None: return 0
            current = dictionary.get(self.head)
            next = dictionary.get(self.tail)
            if current is None: return len(next)
            else: return 1 + len(next)
        return len(self.dictionary)
    def __getitem__(self,index):
        def get(dictionary,index):
            if dictionary is None: raise IndexError
            if index==0:
                current = dictionary.get(self.head)
                next = dictionary.get(self.tail)
                if current is None: return get(next,index)
                else: return current
            else:
                dictionary = dictionary.get(self.tail)
                return get(dictionary,index-1)
        return get(self.dictionary,index)
    def __setitem__(self,index,value):
        def set(dictionary,index,value):
            if dictionary is None: raise IndexError
            if index==0:
                current = dictionary.get(self.head)
                next = dictionary.get(self.tail)
                if current is None: set(next,index,value)
                else: dictionary[self.head]=value
            else:
                dictionary = dictionary.get(self.tail)
                set(dictionary,index-1,value)
        return set(self.dictionary,index,value)
    def __iter__(self):
        self.current = self.dictionary
        return self
    def next(self):
        if self.current is None: raise StopIteration
        current = self.current.get(self.head)
        self.current = self.current.get(self.tail)
        if current is None: return self.next()
        else: return current
    def append(self,value):
        def __append(dictionary,value):
            next = dictionary.get(self.tail)
            if next is None:
                dictionary[self.head] = value
                dictionary[self.tail] = {}
            else: __append(next,value)
        __append(self.dictionary,value)
    def itemValues(self,*args):
        return map(lambda x:tuple(map(lambda y:x.get(y),args)),self)